/* LabelWithWidgets.c generated by valac 0.56.10, the Vala compiler
 * generated from LabelWithWidgets.vala, do not modify */

/* LabelWithWidgets is ported from Fractal*/
/* https://gitlab.gnome.org/GNOME/fractal/-/blob/3f8a7e8bd06441d83a5f052a2ae68d7d228dfcd0/src/components/label_with_widgets.rs*/
/* How to use:*/
/* Set `text` to the label's content but use the `placeholder` keyword where widgets should be placed.*/
/* Then use `set_children` with an array of Widgets in order of how they should be placed in the label.*/
/* There are some helper functions like `append_child` to add children and*/
/* `LabelWithWidgets.with_label_and_widgets` to construct it with the desired text and widgets.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER "\xEF\xBF\xBC"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS (tuba_widgets_label_with_widgets_get_type ())
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))

typedef struct _TubaWidgetsLabelWithWidgets TubaWidgetsLabelWithWidgets;
typedef struct _TubaWidgetsLabelWithWidgetsClass TubaWidgetsLabelWithWidgetsClass;
typedef struct _TubaWidgetsLabelWithWidgetsPrivate TubaWidgetsLabelWithWidgetsPrivate;
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_0_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES
};
static GParamSpec* tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define __vala_PangoLayoutRun_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutRun_free (var), NULL)))
#define __vala_PangoLayoutIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutIter_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS
};
static guint tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS] = {0};

struct _TubaWidgetsLabelWithWidgets {
	GtkWidget parent_instance;
	TubaWidgetsLabelWithWidgetsPrivate * priv;
	GtkLabel* label;
};

struct _TubaWidgetsLabelWithWidgetsClass {
	GtkWidgetClass parent_class;
};

struct _TubaWidgetsLabelWithWidgetsPrivate {
	GtkWidget** widgets;
	gint widgets_length1;
	gint _widgets_size_;
	gint* widget_heights;
	gint widget_heights_length1;
	gint _widget_heights_size_;
	gint* widget_widths;
	gint widget_widths_length1;
	gint _widget_widths_size_;
	gchar* _placeholder;
	gchar* _text;
	gboolean _ellipsize;
	gboolean _use_markup;
};

static gint TubaWidgetsLabelWithWidgets_private_offset;
static gpointer tuba_widgets_label_with_widgets_parent_class = NULL;
static GtkBuildableIface * tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = NULL;
static GtkAccessibleInterface * tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = NULL;

VALA_EXTERN GType tuba_widgets_label_with_widgets_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaWidgetsLabelWithWidgets, g_object_unref)
static void tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self);
static PangoLayoutRun* _vala_PangoLayoutRun_copy (PangoLayoutRun* self);
static gint tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                                   gint d);
static void _vala_PangoLayoutRun_free (PangoLayoutRun* self);
static void _vala_PangoLayoutIter_free (PangoLayoutIter* self);
static void tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                         gint width,
                                                         gint height,
                                                         gint baseline);
static GtkSizeRequestMode tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base);
static void tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                                   GtkOrientation orientation,
                                                   gint for_size,
                                                   gint* minimum,
                                                   gint* natural,
                                                   gint* minimum_baseline,
                                                   gint* natural_baseline);
static void tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gint tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                                gint value);
static void tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget* child);
static void _vala_array_add20 (GtkWidget** * array,
                        gint* length,
                        gint* size,
                        GtkWidget* value);
static void _vala_array_add21 (gint* * array,
                        gint* length,
                        gint* size,
                        gint value);
static void _vala_array_add22 (gint* * array,
                        gint* length,
                        gint* size,
                        gint value);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                                                         GtkWidget** t_widgets,
                                                                                         gint t_widgets_length1);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                                               const gchar* t_text,
                                                                                               GtkWidget** t_widgets,
                                                                                               gint t_widgets_length1);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                               const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget** t_widgets,
                                                   gint t_widgets_length1);
static void tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                     GtkBuilder* builder,
                                                     GObject* child,
                                                     const gchar* type);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new (void);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct (GType object_type);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                      const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                                    gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                           gboolean value);
VALA_EXTERN gfloat tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                                 gfloat value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN GtkJustification tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                                  GtkJustification value);
static void g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * tuba_widgets_label_with_widgets_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static gboolean _tuba_widgets_label_with_widgets___lambda53_ (TubaWidgetsLabelWithWidgets* self,
                                                       const gchar* url);
static gboolean __tuba_widgets_label_with_widgets___lambda53__gtk_label_activate_link (GtkLabel* _sender,
                                                                                const gchar* uri,
                                                                                gpointer self);
static void tuba_widgets_label_with_widgets_finalize (GObject * obj);
static GType tuba_widgets_label_with_widgets_get_type_once (void);
static void _vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
tuba_widgets_label_with_widgets_get_instance_private (TubaWidgetsLabelWithWidgets* self)
{
	return G_STRUCT_MEMBER_P (self, TubaWidgetsLabelWithWidgets_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/Widgets/LabelWithWidgets.vala"
	return self ? g_object_ref (self) : NULL;
#line 224 "LabelWithWidgets.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 248 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 256 "LabelWithWidgets.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 262 "LabelWithWidgets.c"
	}
}

static void
tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self)
{
	gboolean child_size_changed = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkWidget** _tmp2_;
	gint _tmp2__length1;
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp25_;
	gint index = 0;
	GtkLabel* _tmp48_;
	PangoAttrList* _tmp49_;
#line 84 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/Widgets/LabelWithWidgets.vala"
	child_size_changed = FALSE;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = tuba_widgets_label_with_widgets_get_text (self);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 87 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 291 "LabelWithWidgets.c"
	}
#line 88 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->priv->widgets;
#line 88 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2__length1 = self->priv->widgets_length1;
#line 88 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp2__length1 == 0) {
#line 299 "LabelWithWidgets.c"
		GtkLabel* _tmp3_;
#line 89 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = self->label;
#line 89 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_attributes (_tmp3_, NULL);
#line 90 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 307 "LabelWithWidgets.c"
	}
	{
		gint i = 0;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 313 "LabelWithWidgets.c"
		{
			gboolean _tmp4_ = FALSE;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
			_tmp4_ = TRUE;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 320 "LabelWithWidgets.c"
				GtkWidget** _tmp6_;
				gint _tmp6__length1;
				GtkWidget* child = NULL;
				GtkWidget** _tmp7_;
				gint _tmp7__length1;
				GtkWidget* _tmp8_;
				GtkWidget* _tmp9_;
				GtkRequisition size = {0};
				GtkRequisition natural_size = {0};
				GtkWidget* _tmp10_;
				GtkRequisition _tmp11_ = {0};
				GtkRequisition _tmp12_ = {0};
				gint width = 0;
				GtkRequisition _tmp13_;
				gint height = 0;
				GtkRequisition _tmp14_;
				gint old_width = 0;
				gint* _tmp15_;
				gint _tmp15__length1;
				gint _tmp16_;
				gint old_height = 0;
				gint* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp4_) {
#line 348 "LabelWithWidgets.c"
					gint _tmp5_;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
					_tmp5_ = i;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp5_ + 1;
#line 354 "LabelWithWidgets.c"
				}
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = FALSE;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = self->priv->widgets;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6__length1 = self->priv->widgets_length1;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp6__length1)) {
#line 93 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 366 "LabelWithWidgets.c"
				}
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = self->priv->widgets;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7__length1 = self->priv->widgets_length1;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = _tmp7_[i];
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				child = _tmp9_;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				_tmp10_ = child;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_get_preferred_size (_tmp10_, &_tmp11_, &_tmp12_);
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				size = _tmp11_;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				natural_size = _tmp12_;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp13_ = natural_size;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp13_.width;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14_ = natural_size;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp14_.height;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15_ = self->priv->widget_widths;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15__length1 = self->priv->widget_widths_length1;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16_ = _tmp15_[i];
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				old_width = _tmp16_;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
				_tmp17_ = self->priv->widget_heights;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
				_tmp17__length1 = self->priv->widget_heights_length1;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
				_tmp18_ = _tmp17_[i];
#line 102 "../src/Widgets/LabelWithWidgets.vala"
				old_height = _tmp18_;
#line 103 "../src/Widgets/LabelWithWidgets.vala"
				if (old_width > 0) {
#line 103 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = TRUE;
#line 414 "LabelWithWidgets.c"
				} else {
#line 103 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = old_height > 0;
#line 418 "LabelWithWidgets.c"
				}
#line 103 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp19_) {
#line 422 "LabelWithWidgets.c"
					gboolean _tmp20_ = FALSE;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
					if (old_width != width) {
#line 104 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_ = TRUE;
#line 428 "LabelWithWidgets.c"
					} else {
#line 104 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_ = old_height != height;
#line 432 "LabelWithWidgets.c"
					}
#line 104 "../src/Widgets/LabelWithWidgets.vala"
					if (_tmp20_) {
#line 436 "LabelWithWidgets.c"
						gint* _tmp21_;
						gint _tmp21__length1;
						gint* _tmp22_;
						gint _tmp22__length1;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_ = self->priv->widget_widths;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21__length1 = self->priv->widget_widths_length1;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_[i] = width;
#line 106 "../src/Widgets/LabelWithWidgets.vala"
						_tmp22_ = self->priv->widget_heights;
#line 106 "../src/Widgets/LabelWithWidgets.vala"
						_tmp22__length1 = self->priv->widget_heights_length1;
#line 106 "../src/Widgets/LabelWithWidgets.vala"
						_tmp22_[i] = height;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
						child_size_changed = TRUE;
#line 455 "LabelWithWidgets.c"
					}
				} else {
					gint* _tmp23_;
					gint _tmp23__length1;
					gint* _tmp24_;
					gint _tmp24__length1;
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = self->priv->widget_widths;
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23__length1 = self->priv->widget_widths_length1;
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_[i] = width;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
					_tmp24_ = self->priv->widget_heights;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
					_tmp24__length1 = self->priv->widget_heights_length1;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
					_tmp24_[i] = height;
#line 114 "../src/Widgets/LabelWithWidgets.vala"
					child_size_changed = TRUE;
#line 476 "LabelWithWidgets.c"
				}
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 480 "LabelWithWidgets.c"
			}
		}
	}
#line 119 "../src/Widgets/LabelWithWidgets.vala"
	if (!child_size_changed) {
#line 120 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 488 "LabelWithWidgets.c"
	}
#line 123 "../src/Widgets/LabelWithWidgets.vala"
	_tmp25_ = pango_attr_list_new ();
#line 123 "../src/Widgets/LabelWithWidgets.vala"
	attrs = _tmp25_;
#line 124 "../src/Widgets/LabelWithWidgets.vala"
	index = 0;
#line 496 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 501 "LabelWithWidgets.c"
		{
			gboolean _tmp26_ = FALSE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
			_tmp26_ = TRUE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 508 "LabelWithWidgets.c"
				gint* _tmp28_;
				gint _tmp28__length1;
				GtkLabel* _tmp29_;
				const gchar* _tmp30_;
				gint width = 0;
				gint* _tmp31_;
				gint _tmp31__length1;
				gint _tmp32_;
				gint height = 0;
				gint* _tmp33_;
				gint _tmp33__length1;
				gint _tmp34_;
				PangoRectangle logical_rect = {0};
				PangoRectangle _tmp35_ = {0};
				PangoAttribute* shape = NULL;
				PangoRectangle _tmp36_;
				PangoRectangle _tmp37_;
				PangoAttribute* _tmp38_;
				PangoAttribute* _tmp39_;
				PangoAttribute* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				PangoAttrList* _tmp43_;
				PangoAttribute* _tmp44_;
				PangoAttribute* _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp26_) {
#line 538 "LabelWithWidgets.c"
					gint _tmp27_;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
					_tmp27_ = i;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp27_ + 1;
#line 544 "LabelWithWidgets.c"
				}
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp26_ = FALSE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28_ = self->priv->widget_widths;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28__length1 = self->priv->widget_widths_length1;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp28__length1)) {
#line 126 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 556 "LabelWithWidgets.c"
				}
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29_ = self->label;
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = gtk_label_get_text (_tmp29_);
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				index = string_index_of (_tmp30_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER, index);
#line 128 "../src/Widgets/LabelWithWidgets.vala"
				if (index < 0) {
#line 128 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 568 "LabelWithWidgets.c"
				}
#line 130 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_ = self->priv->widget_widths;
#line 130 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31__length1 = self->priv->widget_widths_length1;
#line 130 "../src/Widgets/LabelWithWidgets.vala"
				_tmp32_ = _tmp31_[i];
#line 130 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp32_;
#line 131 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33_ = self->priv->widget_heights;
#line 131 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33__length1 = self->priv->widget_heights_length1;
#line 131 "../src/Widgets/LabelWithWidgets.vala"
				_tmp34_ = _tmp33_[i];
#line 131 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp34_;
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				memset (&_tmp35_, 0, sizeof (PangoRectangle));
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_.x = 0;
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_.y = (-(height - (height / 4))) * PANGO_SCALE;
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_.width = width * PANGO_SCALE;
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_.height = height * PANGO_SCALE;
#line 132 "../src/Widgets/LabelWithWidgets.vala"
				logical_rect = _tmp35_;
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp36_ = logical_rect;
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_ = logical_rect;
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp38_ = pango_attr_shape_new (&_tmp36_, &_tmp37_);
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				shape = _tmp38_;
#line 140 "../src/Widgets/LabelWithWidgets.vala"
				_tmp39_ = shape;
#line 140 "../src/Widgets/LabelWithWidgets.vala"
				_tmp39_->start_index = (guint) index;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp40_ = shape;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_ = _tmp41_;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp40_->end_index = (guint) (index + _tmp42_);
#line 142 "../src/Widgets/LabelWithWidgets.vala"
				_tmp43_ = attrs;
#line 142 "../src/Widgets/LabelWithWidgets.vala"
				_tmp44_ = shape;
#line 142 "../src/Widgets/LabelWithWidgets.vala"
				_tmp45_ = pango_attribute_copy (_tmp44_);
#line 142 "../src/Widgets/LabelWithWidgets.vala"
				pango_attr_list_insert (_tmp43_, _tmp45_);
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				_tmp46_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				_tmp47_ = _tmp46_;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				index = index + _tmp47_;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_pango_attribute_destroy0 (shape);
#line 634 "LabelWithWidgets.c"
			}
		}
	}
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	_tmp48_ = self->label;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	_tmp49_ = attrs;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_attributes (_tmp48_, _tmp49_);
#line 84 "../src/Widgets/LabelWithWidgets.vala"
	_pango_attr_list_unref0 (attrs);
#line 646 "LabelWithWidgets.c"
}

static PangoLayoutRun*
_vala_PangoLayoutRun_copy (PangoLayoutRun* self)
{
#line 155 "../src/Widgets/LabelWithWidgets.vala"
	return g_boxed_copy (pango_glyph_item_get_type (), self);
#line 654 "LabelWithWidgets.c"
}

static gpointer
__vala_PangoLayoutRun_copy0 (gpointer self)
{
#line 155 "../src/Widgets/LabelWithWidgets.vala"
	return self ? _vala_PangoLayoutRun_copy (self) : NULL;
#line 662 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutRun_free (PangoLayoutRun* self)
{
#line 188 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_glyph_item_get_type (), self);
#line 670 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutIter_free (PangoLayoutIter* self)
{
#line 150 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_layout_iter_get_type (), self);
#line 678 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self)
{
	PangoLayoutIter* run_iter = NULL;
	GtkLabel* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayoutIter* _tmp2_;
	gint i = 0;
#line 150 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_layout (_tmp0_);
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = pango_layout_get_iter (_tmp1_);
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	run_iter = _tmp2_;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	i = 0;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
	while (TRUE) {
#line 703 "LabelWithWidgets.c"
		PangoLayoutRun* run = NULL;
		PangoLayoutIter* _tmp3_;
		PangoLayoutRun* _tmp4_;
		PangoLayoutRun* _tmp5_;
		PangoLayoutRun* _tmp6_;
		PangoLayoutIter* _tmp34_;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = run_iter;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = pango_layout_iter_get_run_readonly (_tmp3_);
#line 155 "../src/Widgets/LabelWithWidgets.vala"
		_tmp5_ = __vala_PangoLayoutRun_copy0 (_tmp4_);
#line 155 "../src/Widgets/LabelWithWidgets.vala"
		run = _tmp5_;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
		_tmp6_ = run;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp6_ != NULL) {
#line 722 "LabelWithWidgets.c"
			GSList* extra_attrs = NULL;
			PangoLayoutRun* _tmp7_;
			PangoItem* _tmp8_;
			PangoAnalysis _tmp9_;
			GSList* _tmp10_;
			GSList* _tmp11_;
			gboolean has_shape_attr = FALSE;
			GSList* _tmp12_;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			_tmp7_ = run;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			_tmp8_ = ((PangoGlyphItem*) _tmp7_)->item;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			_tmp9_ = _tmp8_->analysis;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			_tmp10_ = _tmp9_.extra_attrs;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			_tmp11_ = g_slist_copy (_tmp10_);
#line 157 "../src/Widgets/LabelWithWidgets.vala"
			extra_attrs = _tmp11_;
#line 158 "../src/Widgets/LabelWithWidgets.vala"
			has_shape_attr = FALSE;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
			_tmp12_ = extra_attrs;
#line 747 "LabelWithWidgets.c"
			{
				GSList* attr_collection = NULL;
				GSList* attr_it = NULL;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
				attr_collection = _tmp12_;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
				for (attr_it = attr_collection; attr_it != NULL; attr_it = attr_it->next) {
#line 755 "LabelWithWidgets.c"
					void* attr = NULL;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
					attr = attr_it->data;
#line 759 "LabelWithWidgets.c"
					{
						void* _tmp13_;
						PangoAttrShape* _tmp14_;
#line 160 "../src/Widgets/LabelWithWidgets.vala"
						_tmp13_ = attr;
#line 160 "../src/Widgets/LabelWithWidgets.vala"
						_tmp14_ = pango_attribute_as_shape ((PangoAttribute*) _tmp13_);
#line 160 "../src/Widgets/LabelWithWidgets.vala"
						if (_tmp14_ != NULL) {
#line 161 "../src/Widgets/LabelWithWidgets.vala"
							has_shape_attr = TRUE;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
							break;
#line 773 "LabelWithWidgets.c"
						}
					}
				}
			}
#line 166 "../src/Widgets/LabelWithWidgets.vala"
			if (has_shape_attr) {
#line 780 "LabelWithWidgets.c"
				GtkWidget** _tmp15_;
				gint _tmp15__length1;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15_ = self->priv->widgets;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15__length1 = self->priv->widgets_length1;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
				if (i < _tmp15__length1) {
#line 789 "LabelWithWidgets.c"
					GtkWidget* widget = NULL;
					GtkWidget** _tmp16_;
					gint _tmp16__length1;
					GtkWidget* _tmp17_;
					GtkWidget* _tmp18_;
					gint width = 0;
					gint* _tmp19_;
					gint _tmp19__length1;
					gint _tmp20_;
					gint height = 0;
					gint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					PangoRectangle logical_rect = {0};
					PangoLayoutIter* _tmp23_;
					PangoRectangle _tmp24_ = {0};
					gint offset_x = 0;
					gint offset_y = 0;
					GtkLabel* _tmp25_;
					gint _tmp26_ = 0;
					gint _tmp27_ = 0;
					GtkAllocation allocation = {0};
					PangoRectangle _tmp28_;
					PangoRectangle _tmp29_;
					GtkAllocation _tmp30_ = {0};
					GtkWidget* _tmp31_;
					GtkAllocation _tmp32_;
					gint _tmp33_;
#line 168 "../src/Widgets/LabelWithWidgets.vala"
					_tmp16_ = self->priv->widgets;
#line 168 "../src/Widgets/LabelWithWidgets.vala"
					_tmp16__length1 = self->priv->widgets_length1;
#line 168 "../src/Widgets/LabelWithWidgets.vala"
					_tmp17_ = _tmp16_[i];
#line 168 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 168 "../src/Widgets/LabelWithWidgets.vala"
					widget = _tmp18_;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = self->priv->widget_widths;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19__length1 = self->priv->widget_widths_length1;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20_ = _tmp19_[i];
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					width = _tmp20_;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					_tmp21_ = self->priv->widget_heights;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					_tmp21__length1 = self->priv->widget_heights_length1;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_ = _tmp21_[i];
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					height = _tmp22_;
#line 173 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = run_iter;
#line 173 "../src/Widgets/LabelWithWidgets.vala"
					pango_layout_iter_get_run_extents (_tmp23_, NULL, &_tmp24_);
#line 173 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect = _tmp24_;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp25_ = self->label;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					gtk_label_get_layout_offsets (_tmp25_, &_tmp26_, &_tmp27_);
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					offset_x = _tmp26_;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					offset_y = _tmp27_;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp28_ = logical_rect;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp29_ = logical_rect;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					memset (&_tmp30_, 0, sizeof (GtkAllocation));
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.x = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp28_.x) + offset_x;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.y = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp29_.y) + offset_y;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.height = height;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.width = width;
#line 179 "../src/Widgets/LabelWithWidgets.vala"
					allocation = _tmp30_;
#line 185 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_ = widget;
#line 185 "../src/Widgets/LabelWithWidgets.vala"
					_tmp32_ = allocation;
#line 185 "../src/Widgets/LabelWithWidgets.vala"
					gtk_widget_size_allocate (_tmp31_, &_tmp32_, -1);
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					_tmp33_ = i;
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp33_ + 1;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
					_g_object_unref0 (widget);
#line 886 "LabelWithWidgets.c"
				} else {
#line 188 "../src/Widgets/LabelWithWidgets.vala"
					(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 188 "../src/Widgets/LabelWithWidgets.vala"
					__vala_PangoLayoutRun_free0 (run);
#line 188 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 894 "LabelWithWidgets.c"
				}
			}
#line 156 "../src/Widgets/LabelWithWidgets.vala"
			(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 899 "LabelWithWidgets.c"
		}
#line 193 "../src/Widgets/LabelWithWidgets.vala"
		_tmp34_ = run_iter;
#line 193 "../src/Widgets/LabelWithWidgets.vala"
		if (!pango_layout_iter_next_run (_tmp34_)) {
#line 194 "../src/Widgets/LabelWithWidgets.vala"
			__vala_PangoLayoutRun_free0 (run);
#line 194 "../src/Widgets/LabelWithWidgets.vala"
			break;
#line 909 "LabelWithWidgets.c"
		}
#line 154 "../src/Widgets/LabelWithWidgets.vala"
		__vala_PangoLayoutRun_free0 (run);
#line 913 "LabelWithWidgets.c"
	}
#line 150 "../src/Widgets/LabelWithWidgets.vala"
	__vala_PangoLayoutIter_free0 (run_iter);
#line 917 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                    gint width,
                                                    gint height,
                                                    gint baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
#line 199 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 200 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 200 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp0_, width, height, baseline, NULL);
#line 201 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_children (self);
#line 936 "LabelWithWidgets.c"
}

static GtkSizeRequestMode
tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkSizeRequestMode result;
#line 204 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 205 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 205 "../src/Widgets/LabelWithWidgets.vala"
	result = gtk_widget_get_request_mode ((GtkWidget*) _tmp0_);
#line 205 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 953 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                              GtkOrientation orientation,
                                              gint for_size,
                                              gint* minimum,
                                              gint* natural,
                                              gint* minimum_baseline,
                                              gint* natural_baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _vala_minimum_baseline = 0;
	gint _vala_natural_baseline = 0;
	GtkLabel* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum = _tmp1_;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural = _tmp2_;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum_baseline = _tmp3_;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural_baseline = _tmp4_;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum) {
#line 208 "../src/Widgets/LabelWithWidgets.vala"
		*minimum = _vala_minimum;
#line 995 "LabelWithWidgets.c"
	}
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	if (natural) {
#line 208 "../src/Widgets/LabelWithWidgets.vala"
		*natural = _vala_natural;
#line 1001 "LabelWithWidgets.c"
	}
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum_baseline) {
#line 208 "../src/Widgets/LabelWithWidgets.vala"
		*minimum_baseline = _vala_minimum_baseline;
#line 1007 "LabelWithWidgets.c"
	}
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	if (natural_baseline) {
#line 208 "../src/Widgets/LabelWithWidgets.vala"
		*natural_baseline = _vala_natural_baseline;
#line 1013 "LabelWithWidgets.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1036 "LabelWithWidgets.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1040 "LabelWithWidgets.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1046 "LabelWithWidgets.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1050 "LabelWithWidgets.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1054 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1062 "LabelWithWidgets.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1090 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1099 "LabelWithWidgets.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1113 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1122 "LabelWithWidgets.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1136 "LabelWithWidgets.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1145 "LabelWithWidgets.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1154 "LabelWithWidgets.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1176 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 1184 "LabelWithWidgets.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 1190 "LabelWithWidgets.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1214 "LabelWithWidgets.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1223 "LabelWithWidgets.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1242 "LabelWithWidgets.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1246 "LabelWithWidgets.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1252 "LabelWithWidgets.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1262 "LabelWithWidgets.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1270 "LabelWithWidgets.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1274 "LabelWithWidgets.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1280 "LabelWithWidgets.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1290 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self)
{
	gchar* old_label = NULL;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean old_ellipsize = FALSE;
	GtkLabel* _tmp4_;
	PangoEllipsizeMode _tmp5_;
	PangoEllipsizeMode _tmp6_;
	gboolean new_ellipsize = FALSE;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gchar* new_label = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp18_ = FALSE;
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	old_label = _tmp3_;
#line 229 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = self->label;
#line 229 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = gtk_label_get_ellipsize (_tmp4_);
#line 229 "../src/Widgets/LabelWithWidgets.vala"
	_tmp6_ = _tmp5_;
#line 229 "../src/Widgets/LabelWithWidgets.vala"
	old_ellipsize = _tmp6_ == PANGO_ELLIPSIZE_END;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	_tmp7_ = tuba_widgets_label_with_widgets_get_ellipsize (self);
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	_tmp8_ = _tmp7_;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	new_ellipsize = _tmp8_;
#line 231 "../src/Widgets/LabelWithWidgets.vala"
	_tmp9_ = self->priv->_text;
#line 231 "../src/Widgets/LabelWithWidgets.vala"
	_tmp10_ = tuba_widgets_label_with_widgets_get_placeholder (self);
#line 231 "../src/Widgets/LabelWithWidgets.vala"
	_tmp11_ = _tmp10_;
#line 231 "../src/Widgets/LabelWithWidgets.vala"
	_tmp12_ = string_replace (_tmp9_, _tmp11_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 231 "../src/Widgets/LabelWithWidgets.vala"
	new_label = _tmp12_;
#line 233 "../src/Widgets/LabelWithWidgets.vala"
	if (new_ellipsize) {
#line 1352 "LabelWithWidgets.c"
		gint pos = 0;
		const gchar* _tmp13_;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		_tmp13_ = new_label;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		pos = string_index_of_char (_tmp13_, (gunichar) '\n', 0);
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		if (pos >= 0) {
#line 1361 "LabelWithWidgets.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp14_ = new_label;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp15_ = string_substring (_tmp14_, (glong) 0, (glong) pos);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp16_ = _tmp15_;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp17_ = g_strconcat (_tmp16_, "…", NULL);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_g_free0 (new_label);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			new_label = _tmp17_;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_g_free0 (_tmp16_);
#line 1380 "LabelWithWidgets.c"
		}
	}
#line 240 "../src/Widgets/LabelWithWidgets.vala"
	if (old_ellipsize != new_ellipsize) {
#line 240 "../src/Widgets/LabelWithWidgets.vala"
		_tmp18_ = TRUE;
#line 1387 "LabelWithWidgets.c"
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 240 "../src/Widgets/LabelWithWidgets.vala"
		_tmp19_ = old_label;
#line 240 "../src/Widgets/LabelWithWidgets.vala"
		_tmp20_ = new_label;
#line 240 "../src/Widgets/LabelWithWidgets.vala"
		_tmp18_ = g_strcmp0 (_tmp19_, _tmp20_) != 0;
#line 1397 "LabelWithWidgets.c"
	}
#line 240 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp18_) {
#line 1401 "LabelWithWidgets.c"
		const gchar* _tmp34_;
		gchar* _tmp35_;
		GtkLabel* _tmp36_;
		const gchar* _tmp37_;
#line 241 "../src/Widgets/LabelWithWidgets.vala"
		if (new_ellipsize) {
#line 1408 "LabelWithWidgets.c"
			GtkLabel* _tmp21_;
			GtkLabel* _tmp22_;
#line 244 "../src/Widgets/LabelWithWidgets.vala"
			_tmp21_ = self->label;
#line 244 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_wrap (_tmp21_, FALSE);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
			_tmp22_ = self->label;
#line 245 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_ellipsize (_tmp22_, PANGO_ELLIPSIZE_END);
#line 1419 "LabelWithWidgets.c"
		} else {
			GtkLabel* _tmp23_;
			GtkLabel* _tmp24_;
			gboolean _tmp25_ = FALSE;
			gint _tmp26_;
			gint _tmp27_;
			PangoEllipsizeMode _tmp30_ = 0;
			gint _tmp31_;
			gint _tmp32_;
			GtkLabel* _tmp33_;
#line 247 "../src/Widgets/LabelWithWidgets.vala"
			_tmp23_ = self->label;
#line 247 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_wrap (_tmp23_, TRUE);
#line 248 "../src/Widgets/LabelWithWidgets.vala"
			_tmp24_ = self->label;
#line 248 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_wrap_mode (_tmp24_, PANGO_WRAP_WORD_CHAR);
#line 251 "../src/Widgets/LabelWithWidgets.vala"
			_tmp26_ = tuba_widgets_label_with_widgets_get_lines (self);
#line 251 "../src/Widgets/LabelWithWidgets.vala"
			_tmp27_ = _tmp26_;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
			if (_tmp27_ == 100) {
#line 1444 "LabelWithWidgets.c"
				GtkWidget** _tmp28_;
				gint _tmp28__length1;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28_ = self->priv->widgets;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28__length1 = self->priv->widgets_length1;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp25_ = _tmp28__length1 > 100;
#line 1453 "LabelWithWidgets.c"
			} else {
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp25_ = FALSE;
#line 1457 "LabelWithWidgets.c"
			}
#line 251 "../src/Widgets/LabelWithWidgets.vala"
			if (_tmp25_) {
#line 1461 "LabelWithWidgets.c"
				GtkWidget** _tmp29_;
				gint _tmp29__length1;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29_ = self->priv->widgets;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29__length1 = self->priv->widgets_length1;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_set_lines (self, _tmp29__length1);
#line 1470 "LabelWithWidgets.c"
			}
#line 252 "../src/Widgets/LabelWithWidgets.vala"
			_tmp31_ = tuba_widgets_label_with_widgets_get_lines (self);
#line 252 "../src/Widgets/LabelWithWidgets.vala"
			_tmp32_ = _tmp31_;
#line 252 "../src/Widgets/LabelWithWidgets.vala"
			if (_tmp32_ < 100) {
#line 252 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = PANGO_ELLIPSIZE_NONE;
#line 1480 "LabelWithWidgets.c"
			} else {
#line 252 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = PANGO_ELLIPSIZE_END;
#line 1484 "LabelWithWidgets.c"
			}
#line 252 "../src/Widgets/LabelWithWidgets.vala"
			_tmp33_ = self->label;
#line 252 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_ellipsize (_tmp33_, _tmp30_);
#line 1490 "LabelWithWidgets.c"
		}
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		_tmp34_ = new_label;
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		_tmp35_ = g_strdup (_tmp34_);
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_text);
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_text = _tmp35_;
#line 256 "../src/Widgets/LabelWithWidgets.vala"
		_tmp36_ = self->label;
#line 256 "../src/Widgets/LabelWithWidgets.vala"
		_tmp37_ = self->priv->_text;
#line 256 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_label (_tmp36_, _tmp37_);
#line 257 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1508 "LabelWithWidgets.c"
	}
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (new_label);
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (old_label);
#line 1514 "LabelWithWidgets.c"
}

static void
_vala_array_add20 (GtkWidget** * array,
                   gint* length,
                   gint* size,
                   GtkWidget* value)
{
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (GtkWidget*, *array, (*size) + 1);
#line 1529 "LabelWithWidgets.c"
	}
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[*length] = NULL;
#line 1535 "LabelWithWidgets.c"
}

static void
_vala_array_add21 (gint* * array,
                   gint* length,
                   gint* size,
                   gint value)
{
#line 263 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 263 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 263 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (gint, *array, *size);
#line 1550 "LabelWithWidgets.c"
	}
#line 263 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 1554 "LabelWithWidgets.c"
}

static void
_vala_array_add22 (gint* * array,
                   gint* length,
                   gint* size,
                   gint value)
{
#line 264 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 264 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 264 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (gint, *array, *size);
#line 1569 "LabelWithWidgets.c"
	}
#line 264 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 1573 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget* child)
{
	GtkWidget* _tmp0_;
#line 261 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (child);
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add20 (&self->priv->widgets, &self->priv->widgets_length1, &self->priv->_widgets_size_, _tmp0_);
#line 263 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add21 (&self->priv->widget_widths, &self->priv->widget_widths_length1, &self->priv->_widget_widths_size_, 0);
#line 264 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add22 (&self->priv->widget_heights, &self->priv->widget_heights_length1, &self->priv->_widget_heights_size_, 0);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent (child, (GtkWidget*) self);
#line 268 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1597 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                  const gchar* t_text,
                                                                  GtkWidget** t_widgets,
                                                                  gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (t_text != NULL, NULL);
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 1611 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1623 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1627 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp0_;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = widget;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp0_);
#line 1634 "LabelWithWidgets.c"
			}
		}
	}
#line 278 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_set_text (self, t_text);
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1642 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                            GtkWidget** t_widgets,
                                                            gint t_widgets_length1)
{
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct_with_label_and_widgets (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, t_text, t_widgets, t_widgets_length1);
#line 1652 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget** t_widgets,
                                              gint t_widgets_length1)
{
	GtkWidget** _tmp0_;
	gint _tmp0__length1;
	GtkWidget** _tmp4_;
	gint* _tmp5_;
	gint* _tmp6_;
#line 281 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 1671 "LabelWithWidgets.c"
	{
		GtkWidget** child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp0_;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp0__length1;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 1683 "LabelWithWidgets.c"
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
			_tmp1_ = _g_object_ref0 (child_collection[child_it]);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp1_;
#line 1690 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp2_;
				GtkWidget* _tmp3_;
#line 283 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = child;
#line 283 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp2_);
#line 284 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 284 "../src/Widgets/LabelWithWidgets.vala"
				g_signal_emit_by_name (_tmp3_, "destroy");
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 1704 "LabelWithWidgets.c"
			}
		}
	}
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = g_new0 (GtkWidget*, 0 + 1);
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_array_free (self->priv->widgets, self->priv->widgets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp4_;
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = g_new0 (gint, 0);
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = (g_free (self->priv->widget_widths), NULL);
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = _tmp5_;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths_length1 = 0;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_widths_size_ = self->priv->widget_widths_length1;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_tmp6_ = g_new0 (gint, 0);
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = (g_free (self->priv->widget_heights), NULL);
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = _tmp6_;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights_length1 = 0;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_heights_size_ = self->priv->widget_heights_length1;
#line 1738 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1750 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1754 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp7_;
#line 292 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = widget;
#line 292 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp7_);
#line 1761 "LabelWithWidgets.c"
			}
		}
	}
}

static void
tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self)
{
#line 296 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 1772 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 1777 "LabelWithWidgets.c"
		{
			gboolean _tmp0_ = FALSE;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
			_tmp0_ = TRUE;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 1784 "LabelWithWidgets.c"
				gint* _tmp2_;
				gint _tmp2__length1;
				gint* _tmp3_;
				gint _tmp3__length1;
				gint* _tmp4_;
				gint _tmp4__length1;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp0_) {
#line 1793 "LabelWithWidgets.c"
					gint _tmp1_;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
					_tmp1_ = i;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp1_ + 1;
#line 1799 "LabelWithWidgets.c"
				}
#line 297 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = FALSE;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = self->priv->widget_widths;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2__length1 = self->priv->widget_widths_length1;
#line 297 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp2__length1)) {
#line 297 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1811 "LabelWithWidgets.c"
				}
#line 298 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widget_widths;
#line 298 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widget_widths_length1;
#line 298 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_[i] = 0;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = self->priv->widget_heights;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4__length1 = self->priv->widget_heights_length1;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_[i] = 0;
#line 1825 "LabelWithWidgets.c"
			}
		}
	}
#line 301 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 302 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 1833 "LabelWithWidgets.c"
}

static gint
tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                              gint d)
{
	gint result;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	result = (d + 512) >> 10;
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1847 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                GtkBuilder* builder,
                                                GObject* child,
                                                const gchar* type)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (builder != NULL);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()) ? ((GtkWidget*) child) : NULL);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	widget = _tmp0_;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = widget;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp1_ != NULL) {
#line 1874 "LabelWithWidgets.c"
		GtkWidget* _tmp2_;
#line 312 "../src/Widgets/LabelWithWidgets.vala"
		_tmp2_ = widget;
#line 312 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_append_child (self, _tmp2_);
#line 1880 "LabelWithWidgets.c"
	} else {
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = _tmp3_;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) _tmp4_, builder, child, type);
#line 1890 "LabelWithWidgets.c"
	}
#line 317 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), builder, child, type);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (widget);
#line 1896 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct (GType object_type)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1907 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new (void)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS);
#line 1915 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 19 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_placeholder;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1931 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp0_;
#line 24 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY]);
#line 1951 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_text;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1967 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 33 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp0_;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 36 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 36 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify ((GObject*) _tmp1_, "label");
#line 33 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY]);
#line 1992 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 42 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_ellipsize;
#line 43 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2005 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                               gboolean value)
{
#line 45 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_ellipsize = value;
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 45 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY]);
#line 2020 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_use_markup;
#line 54 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2033 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 56 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = value;
#line 58 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 58 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, self->priv->_use_markup);
#line 56 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY]);
#line 2051 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_single_line_mode (_tmp0_);
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 323 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2073 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                      gboolean value)
{
	GtkLabel* _tmp0_;
#line 324 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 324 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_single_line_mode (_tmp0_, value);
#line 324 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY]);
#line 2089 "LabelWithWidgets.c"
}

gfloat
tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_xalign (_tmp0_);
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2111 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                            gfloat value)
{
	GtkLabel* _tmp0_;
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, value);
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY]);
#line 2127 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2149 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_selectable (_tmp0_, value);
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY]);
#line 2165 "LabelWithWidgets.c"
}

gint
tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self)
{
	gint result;
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_lines (_tmp0_);
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 338 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2187 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                           gint value)
{
	GtkLabel* _tmp0_;
#line 339 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 339 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_lines (_tmp0_, value);
#line 339 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY]);
#line 2203 "LabelWithWidgets.c"
}

GtkJustification
tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self)
{
	GtkJustification result;
	GtkLabel* _tmp0_;
	GtkJustification _tmp1_;
	GtkJustification _tmp2_;
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_justify (_tmp0_);
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2225 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                             GtkJustification value)
{
	GtkLabel* _tmp0_;
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_justify (_tmp0_, value);
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY]);
#line 2241 "LabelWithWidgets.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__STRING) (gpointer data1, const char* arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (return_value != NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (n_param_values == 2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = closure->data;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = param_values->data[0].v_pointer;
#line 2269 "LabelWithWidgets.c"
	} else {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = param_values->data[0].v_pointer;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = closure->data;
#line 2275 "LabelWithWidgets.c"
	}
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	callback = (GMarshalFunc_BOOLEAN__STRING) (marshal_data ? marshal_data : cc->callback);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	v_return = callback (data1, g_value_get_string (param_values + 1), data2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_value_set_boolean (return_value, v_return);
#line 2283 "LabelWithWidgets.c"
}

static gboolean
_tuba_widgets_label_with_widgets___lambda53_ (TubaWidgetsLabelWithWidgets* self,
                                              const gchar* url)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_emit (self, tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL], 0, url, &_tmp0_);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2300 "LabelWithWidgets.c"
}

static gboolean
__tuba_widgets_label_with_widgets___lambda53__gtk_label_activate_link (GtkLabel* _sender,
                                                                       const gchar* uri,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuba_widgets_label_with_widgets___lambda53_ ((TubaWidgetsLabelWithWidgets*) self, uri);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2312 "LabelWithWidgets.c"
}

static GObject *
tuba_widgets_label_with_widgets_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	parent_class = G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap (_tmp0_, TRUE);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap_mode (_tmp0_, PANGO_WRAP_WORD_CHAR);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, 0.0f);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	g_object_ref_sink (_tmp0_);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	self->label = _tmp0_;
#line 73 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 73 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp1_, (GtkWidget*) self);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->label;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_connect_object (_tmp2_, "activate-link", (GCallback) __tuba_widgets_label_with_widgets___lambda53__gtk_label_activate_link, self, 0);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	return obj;
#line 2358 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_class_init (TubaWidgetsLabelWithWidgetsClass * klass,
                                            gpointer klass_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_type_class_adjust_private_offset (klass, &TubaWidgetsLabelWithWidgets_private_offset);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) tuba_widgets_label_with_widgets_real_size_allocate;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) tuba_widgets_label_with_widgets_real_get_request_mode;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) tuba_widgets_label_with_widgets_real_measure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuba_widgets_label_with_widgets_get_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuba_widgets_label_with_widgets_set_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->constructor = tuba_widgets_label_with_widgets_constructor;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->finalize = tuba_widgets_label_with_widgets_finalize;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY] = g_param_spec_string ("placeholder", "placeholder", "placeholder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY] = g_param_spec_boolean ("ellipsize", "ellipsize", "ellipsize", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY] = g_param_spec_boolean ("use-markup", "use-markup", "use-markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY] = g_param_spec_boolean ("single-line-mode", "single-line-mode", "single-line-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY] = g_param_spec_int ("lines", "lines", "lines", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY] = g_param_spec_enum ("justify", "justify", "justify", gtk_justification_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL] = g_signal_new ("activate-link", TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__STRING, G_TYPE_BOOLEAN, 1, G_TYPE_STRING);
#line 2403 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                              gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) tuba_widgets_label_with_widgets_real_add_child;
#line 2414 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_accessible_interface_init (GtkAccessibleInterface * iface,
                                                               gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = g_type_interface_peek_parent (iface);
#line 2423 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_instance_init (TubaWidgetsLabelWithWidgets * self,
                                               gpointer klass)
{
	GtkWidget** _tmp0_;
	gint* _tmp1_;
	gint* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self->priv = tuba_widgets_label_with_widgets_get_instance_private (self);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_new0 (GtkWidget*, 0 + 1);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp0_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = g_new0 (gint, 0);
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = _tmp1_;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights_length1 = 0;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_heights_size_ = self->priv->widget_heights_length1;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = g_new0 (gint, 0);
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = _tmp2_;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths_length1 = 0;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_widths_size_ = self->priv->widget_widths_length1;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup ("<widget>");
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp3_;
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = g_strdup ("");
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp4_;
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_ellipsize = FALSE;
#line 51 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = FALSE;
#line 2473 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_finalize (GObject * obj)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkWidget** _tmp1_;
	gint _tmp1__length1;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 78 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 78 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 79 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->priv->widgets;
#line 79 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1__length1 = self->priv->widgets_length1;
#line 2493 "LabelWithWidgets.c"
	{
		GtkWidget** child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 79 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp1_;
#line 79 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp1__length1;
#line 79 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 2505 "LabelWithWidgets.c"
			GtkWidget* _tmp2_;
			GtkWidget* child = NULL;
#line 79 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = _g_object_ref0 (child_collection[child_it]);
#line 79 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp2_;
#line 2512 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp3_;
#line 80 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 80 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp3_);
#line 79 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 2521 "LabelWithWidgets.c"
			}
		}
	}
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_array_free (self->priv->widgets, self->priv->widgets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = (g_free (self->priv->widget_heights), NULL);
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = (g_free (self->priv->widget_widths), NULL);
#line 15 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class)->finalize (obj);
#line 2539 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TubaWidgetsLabelWithWidgetsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_widgets_label_with_widgets_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaWidgetsLabelWithWidgets), 0, (GInstanceInitFunc) tuba_widgets_label_with_widgets_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_accessible_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_accessible_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuba_widgets_label_with_widgets_type_id;
	tuba_widgets_label_with_widgets_type_id = g_type_register_static (gtk_widget_get_type (), "TubaWidgetsLabelWithWidgets", &g_define_type_info, 0);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_accessible_get_type (), &gtk_accessible_info);
	TubaWidgetsLabelWithWidgets_private_offset = g_type_add_instance_private (tuba_widgets_label_with_widgets_type_id, sizeof (TubaWidgetsLabelWithWidgetsPrivate));
	return tuba_widgets_label_with_widgets_type_id;
}

GType
tuba_widgets_label_with_widgets_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_type_id__once)) {
		GType tuba_widgets_label_with_widgets_type_id;
		tuba_widgets_label_with_widgets_type_id = tuba_widgets_label_with_widgets_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_type_id__once, tuba_widgets_label_with_widgets_type_id);
	}
	return tuba_widgets_label_with_widgets_type_id__once;
}

static void
_vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_placeholder (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_ellipsize (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_use_markup (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_single_line_mode (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_float (value, tuba_widgets_label_with_widgets_get_xalign (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_selectable (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_int (value, tuba_widgets_label_with_widgets_get_lines (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_enum (value, tuba_widgets_label_with_widgets_get_justify (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2632 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2638 "LabelWithWidgets.c"
	}
}

static void
_vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_placeholder (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_text (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_ellipsize (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_use_markup (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_single_line_mode (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_xalign (self, g_value_get_float (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_selectable (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_lines (self, g_value_get_int (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_justify (self, g_value_get_enum (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2706 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2712 "LabelWithWidgets.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

